QwtScaleEngine(3)

NAME
QwtScaleEngine -

SYNOPSIS

#include <qwt_scale_engine.h>

Inherited by QwtLinearScaleEngine, and QwtLog10ScaleEngine.

  Public Types
enum Attribute { NoAttribute = 0x00, IncludeReference = 0x01, Symmetric = 0x02, Floating = 0x04, Inverted = 0x08 }
typedef QFlags< Attribute > Attributes

  Public Member Functions
QwtScaleEngine ()
virtual ~QwtScaleEngine ()
Attributes attributes () const
virtual void autoScale (int maxNumSteps, double &x1, double &x2, double &stepSize) const =0
virtual QwtScaleDiv divideScale (double x1, double x2, int maxMajSteps, int maxMinSteps, double stepSize=0.0) const =0
double lowerMargin () const
double reference () const
void setAttribute (Attribute, bool on=true)
void setAttributes (Attributes)
void setMargins (double lower, double upper)
void setReference (double reference)
bool testAttribute (Attribute) const
virtual QwtScaleTransformation * transformation () const =0
double upperMargin () const

  Protected Member Functions
QwtInterval buildInterval (double v) const
bool contains (const QwtInterval &, double val) const
double divideInterval (double interval, int numSteps) const
QList< double > strip (const QList< double > &, const QwtInterval &) const

Detailed Description

Base class for scale engines. A scale engine tries to find 'reasonable' ranges and step sizes for scales.

The layout of the scale can be varied with setAttribute().

Qwt offers implementations for logarithmic (log10) and linear scales. Contributions for other types of scale engines (date/time, log2 ... ) are welcome.

Member Enumeration Documentation

  enum QwtScaleEngine::Attribute
Layout attributes

See also:
    setAttribute(), testAttribute(), reference(), lowerMargin(), upperMargin()

Enumerator:

NoAttribute
    No attributes.

IncludeReference
    Build a scale which includes the reference() value.

Symmetric
    Build a scale which is symmetric to the reference() value.

Floating
    The endpoints of the scale are supposed to be equal the outmost included values plus the specified margins (see setMargins()). If this attribute is not set, the endpoints of the scale will be integer multiples of the step size.

Inverted
    Turn the scale upside down.

Member Function Documentation

  QwtScaleEngine::Attributes QwtScaleEngine::attributes () const
Return the scale attributes

See also:
    Attribute, setAttributes(), testAttribute()

  virtual void QwtScaleEngine::autoScale (intmaxNumSteps, double &x1, double &x2, double &stepSize) const [pure virtual]
Align and divide an interval

Parameters:
    maxNumSteps Max. number of steps
    x1 First limit of the interval (In/Out)
    x2 Second limit of the interval (In/Out)
    stepSize Step size (Return value)

Implemented in QwtLog10ScaleEngine, and QwtLinearScaleEngine.

  QwtInterval QwtScaleEngine::buildInterval (doublev) const [protected]

Build an interval for a value. In case of v == 0.0 the interval is [-0.5, 0.5], otherwide it is [0.5 * v, 1.5 * v]

  bool QwtScaleEngine::contains (const QwtInterval &interval, doublevalue) const [protected]
Check if an interval 'contains' a value

Parameters:
    interval Interval
    value Value

See also:
    QwtScaleArithmetic::compareEps()

  double QwtScaleEngine::divideInterval (doubleintervalSize, intnumSteps) const [protected]
Calculate a step size for an interval size

Parameters:
    intervalSize Interval size
    numSteps Number of steps

Returns:
    Step size

  virtual QwtScaleDiv QwtScaleEngine::divideScale (doublex1, doublex2, intmaxMajSteps, intmaxMinSteps, doublestepSize = 0.0) const [pure virtual]

Calculate a scale division. Parameters:
    x1 First interval limit
    x2 Second interval limit
    maxMajSteps Maximum for the number of major steps
    maxMinSteps Maximum number of minor steps
    stepSize Step size. If stepSize == 0.0, the scaleEngine calculates one.

Implemented in QwtLog10ScaleEngine, and QwtLinearScaleEngine.

  double QwtScaleEngine::lowerMargin () const
Returns:
    the margin at the lower end of the scale The default margin is 0.

See also:
    setMargins()

  double QwtScaleEngine::reference () const
Returns:
    the reference value

See also:
    setReference(), setAttribute()

  void QwtScaleEngine::setAttribute (Attributeattribute, boolon = true)
Change a scale attribute

Parameters:
    attribute Attribute to change
    on On/Off

See also:
    Attribute, testAttribute()

  void QwtScaleEngine::setAttributes (Attributesattributes)
Change the scale attribute

Parameters:
    attributes Set scale attributes

See also:
    Attribute, attributes()

  void QwtScaleEngine::setMargins (doublelower, doubleupper)

Specify margins at the scale's endpoints. Parameters:
    lower minimum distance between the scale's lower boundary and the smallest enclosed value
    upper minimum distance between the scale's upper boundary and the greatest enclosed value

Margins can be used to leave a minimum amount of space between the enclosed intervals and the boundaries of the scale.

Warning:
    •   QwtLog10ScaleEngine measures the margins in decades.
See also:
    upperMargin(), lowerMargin()

  void QwtScaleEngine::setReference (doubler)
Specify a reference point. Parameters:
    r new reference value
The reference point is needed if options IncludeReference or Symmetric are active. Its default value is 0.0.
See also:
    Attribute

  QList< double > QwtScaleEngine::strip (const QList< double > &ticks, const QwtInterval &interval) const [protected]
Remove ticks from a list, that are not inside an interval
Parameters:
    ticks Tick list
    interval Interval
Returns:
    Stripped tick list

  bool QwtScaleEngine::testAttribute (Attributeattribute) const
Check if a attribute is set.
Parameters:
    attribute Attribute to be tested
See also:
    Attribute, setAttribute()

  virtual QwtScaleTransformation* QwtScaleEngine::transformation () const [pure virtual]
Returns:
    a transformation
Implemented in QwtLog10ScaleEngine, and QwtLinearScaleEngine.

  double QwtScaleEngine::upperMargin () const
Returns:
    the margin at the upper end of the scale The default margin is 0.
See also:
    setMargins()

Author
Generated automatically by Doxygen for Qwt User's Guide from the source code.